#jinja2: lstrip_blocks: "True", trim_blocks: "True"
{% set project_name = ( systemd_docker_service_project_name | sanitize_names_for_docker())  %}
{% set service_name = item.key %}
{% set service_name_sanitized = ( service_name | sanitize_names_for_docker()) %}
{% set instance_id = (systemd_docker_service_instance_id | default("1")) %}
{% set exec_start_run = 'ExecStart=/usr/bin/docker run ' %}
{% set indentation_length = ( exec_start_run | length ) %}
{% set linked_services = systemd_docker_service_compose | get_linked_services(project_name=project_name, service_name=service_name, instance_id=instance_id) %}
{% if item.value.container_name is defined %}
  {% set container_name = item.value.container_name %}
{% else %}
  {% set container_name = project_name + '_' + service_name_sanitized + '_' + (instance_id | string) %}
{% endif %}
[Unit]
Description={{ item.value.description | default(item.key) }}
After=docker.service
Requires=docker.service
{% for service in linked_services %}
After={{ service }}.service
Wants={{ service }}.service{% if not loop.last %}
{% endif %}
{% endfor %}

[Service]
TimeoutStartSec=0
ExecStartPre=-/usr/bin/docker kill {{ container_name }}
ExecStartPre=-/usr/bin/docker rm {{ container_name }}
{{ exec_start_run }}--name {{ container_name }} \
{% set docker_args = item.value.keys() | difference(systemd_docker_service_reserved_keywords) %}
{% for key in docker_args %}
{% set value=item.value[key] %}
{% if value is string %}
                              --{{ key | replace('_' ,'-') }}={{ value }} \
{% elif value is mapping %}
                              --{{ key | replace('_' ,'-') }}={{ value | to_json | quote }} \
{% elif value is iterable %}
{% for v in value %}
                              --{{ key | replace('_' ,'-') }}={{ v }} \
{% endfor %}{% endif %}{% endfor %}
{% if item.value.network_mode is defined %}{{ lookup('template','compose_keys/network_mode') | indent(indentation_length, indentfirst=True) }}
{% endif %}
{% for port in item.value.ports | default([]) %}
                              -p "{{ port }}" \
{% endfor %}
{% for volume in item.value.volumes | default([]) %}
                              -v "{{ volume }}" \
{% endfor %}
{% if item is mapping %}{% for key,value in (item.value.environment | default({})).iteritems() %}
                              -e "{{ key }}={{ value }}" \
{% endfor %}{% elif item is iterable %}{% for volume in item.value.environment %}
                              -e "{{ volume }}" \
{% endfor %}{% endif %}
                              {{ item.value.image }}{% if item.value.command is defined and item.value.command %} \
{% endif %}
{% if item.value.command is defined %}{% for arg in item.value.command %}
                              {{ arg }}{% if not loop.last %} \
{% endif %}
{% endfor %}
{% endif %}

[Install]
WantedBy=multi-user.target
